import { IStopTime } from "#ie/ropid-gtfs/interfaces/TripModelInterfaces";
import { IUpdateDelayInput } from "#ie/vehicle-positions/workers/vehicle-positions/interfaces/IUpdateDelayInput";
import { IComputationTrip } from "#ie/vehicle-positions/workers/vehicle-positions/interfaces/VPInterfaces";
import { StatePositionEnum, StateProcessEnum } from "src/const";

const trips_id = "2023-10-11T15:22:00+02:00_119_1131_230918_5997";

export const vpUpdateDelayTask1: {
    trips_id: string;
    input: IUpdateDelayInput;
    gtfsTripDelayComputation: IComputationTrip;
} = {
    trips_id,
    input: {
        updatedTrips: [
            {
                id: trips_id,
                end_timestamp: "2023-10-11T13:39:00.000Z",
                gtfs_route_type: 3,
                gtfs_trip_id: "119_1131_230918",
                internal_route_name: "119",
                internal_run_number: 16,
                start_timestamp: "2023-10-11T13:22:00.000Z",
                vehicle_registration_number: 5997,
            },
        ],
        positions: [
            {
                asw_last_stop_id: "04620015",
                bearing: null,
                cis_last_stop_id: null,
                cis_last_stop_sequence: null,
                delay_stop_arrival: null,
                delay_stop_departure: null,
                is_canceled: false,
                is_tracked: false,
                lat: 50.09358,
                lng: 14.33473,
                origin_time: "14:19:17Z",
                origin_timestamp: new Date("2023-10-11T13:19:17.000Z"),
                speed: null,
                state_position: StatePositionEnum.BEFORE_TRACK_DELAYED,
                state_process: StateProcessEnum.INPUT,
                trips_id,
            },
            {
                asw_last_stop_id: "04620015",
                bearing: null,
                cis_last_stop_id: null,
                cis_last_stop_sequence: null,
                delay_stop_arrival: null,
                delay_stop_departure: null,
                is_canceled: false,
                is_tracked: false,
                lat: 50.09564,
                lng: 14.34728,
                origin_time: "14:20:38Z",
                origin_timestamp: new Date("2023-10-11T13:20:38.000Z"),
                speed: null,
                state_position: StatePositionEnum.BEFORE_TRACK,
                state_process: StateProcessEnum.INPUT,
                trips_id,
            },
        ],
    },
    gtfsTripDelayComputation: {
        trip_id: "119_1131_230918",
        shapes: [],
        stop_times: [
            {
                shape_dist_traveled: 0,
                stop_headsign: null,
                stop_id: "U462Z11P",
                stop_sequence: 1,
                arrival_time_seconds: 55320,
                departure_time_seconds: 55320,
                stop: {
                    stop_id: "U462Z11P",
                    stop_lat: 50.095436,
                    stop_lon: 14.346771,
                    stop_name: "Nádraží Veleslavín",
                },
            },
            {
                shape_dist_traveled: 1.625936,
                stop_headsign: null,
                stop_id: "U85Z5P",
                stop_sequence: 2,
                arrival_time_seconds: 55500,
                departure_time_seconds: 55500,
                stop: {
                    stop_id: "U85Z5P",
                    stop_lat: 50.092724,
                    stop_lon: 14.326629,
                    stop_name: "Divoká Šárka",
                },
            },
        ] as unknown as IStopTime[],
        shapes_anchor_points: [
            {
                index: 0,
                at_stop: true,
                bearing: 72,
                coordinates: [14.34679, 50.09539],
                distance_from_last_stop: 0,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0,
                this_stop_sequence: 1,
                time_scheduled_seconds: 55320,
            },
            {
                index: 1,
                at_stop: true,
                bearing: 18,
                coordinates: [14.34693, 50.09542],
                distance_from_last_stop: 0.011,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.011,
                this_stop_sequence: 1,
                time_scheduled_seconds: 55320,
            },
            {
                index: 2,
                at_stop: false,
                bearing: 255,
                coordinates: [14.34718, 50.09592],
                distance_from_last_stop: 0.111,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.111,
                this_stop_sequence: null,
                time_scheduled_seconds: 55332,
            },
            {
                index: 3,
                at_stop: false,
                bearing: 255,
                coordinates: [14.34583, 50.09568],
                distance_from_last_stop: 0.211,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.211,
                this_stop_sequence: null,
                time_scheduled_seconds: 55343,
            },
            {
                index: 4,
                at_stop: false,
                bearing: 255,
                coordinates: [14.34448, 50.09545],
                distance_from_last_stop: 0.312,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.312,
                this_stop_sequence: null,
                time_scheduled_seconds: 55355,
            },
            {
                index: 5,
                at_stop: false,
                bearing: 255,
                coordinates: [14.34313, 50.09521],
                distance_from_last_stop: 0.412,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.412,
                this_stop_sequence: null,
                time_scheduled_seconds: 55366,
            },
            {
                index: 6,
                at_stop: false,
                bearing: 255,
                coordinates: [14.34178, 50.09497],
                distance_from_last_stop: 0.512,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.512,
                this_stop_sequence: null,
                time_scheduled_seconds: 55377,
            },
            {
                index: 7,
                at_stop: false,
                bearing: 254,
                coordinates: [14.34042, 50.09473],
                distance_from_last_stop: 0.612,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.612,
                this_stop_sequence: null,
                time_scheduled_seconds: 55388,
            },
            {
                index: 8,
                at_stop: false,
                bearing: 254,
                coordinates: [14.33908, 50.09448],
                distance_from_last_stop: 0.713,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.713,
                this_stop_sequence: null,
                time_scheduled_seconds: 55399,
            },
            {
                index: 9,
                at_stop: false,
                bearing: 255,
                coordinates: [14.33773, 50.09423],
                distance_from_last_stop: 0.813,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.813,
                this_stop_sequence: null,
                time_scheduled_seconds: 55410,
            },
            {
                index: 10,
                at_stop: false,
                bearing: 255,
                coordinates: [14.33638, 50.09399],
                distance_from_last_stop: 0.913,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 0.913,
                this_stop_sequence: null,
                time_scheduled_seconds: 55421,
            },
            {
                index: 11,
                at_stop: false,
                bearing: 255,
                coordinates: [14.33503, 50.09375],
                distance_from_last_stop: 1.014,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.014,
                this_stop_sequence: null,
                time_scheduled_seconds: 55432,
            },
            {
                index: 12,
                at_stop: false,
                bearing: 257,
                coordinates: [14.33368, 50.09351],
                distance_from_last_stop: 1.114,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.114,
                this_stop_sequence: null,
                time_scheduled_seconds: 55443,
            },
            {
                index: 13,
                at_stop: false,
                bearing: 259,
                coordinates: [14.33231, 50.09331],
                distance_from_last_stop: 1.214,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.214,
                this_stop_sequence: null,
                time_scheduled_seconds: 55454,
            },
            {
                index: 14,
                at_stop: false,
                bearing: 260,
                coordinates: [14.33094, 50.09314],
                distance_from_last_stop: 1.314,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.314,
                this_stop_sequence: null,
                time_scheduled_seconds: 55465,
            },
            {
                index: 15,
                at_stop: false,
                bearing: 260,
                coordinates: [14.32955, 50.09299],
                distance_from_last_stop: 1.415,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.415,
                this_stop_sequence: null,
                time_scheduled_seconds: 55477,
            },
            {
                index: 16,
                at_stop: false,
                bearing: 261,
                coordinates: [14.32817, 50.09284],
                distance_from_last_stop: 1.515,
                last_stop_sequence: 1,
                next_stop_sequence: 2,
                shape_dist_traveled: 1.515,
                this_stop_sequence: null,
                time_scheduled_seconds: 55488,
            },
        ],
    },
};
